#pragma once

#include <string>
#include <map>
#include "vect.h"
#include "array2d.h"

using namespace std;

void load_into(Array2D<vect4f> &img, string fn);
void save_image(string fn, Array2D<vect4f> &in, int bits);

struct Image
{
	Image();
	Image(string fn);
	~Image();

	unsigned int size[2];
	unsigned int gl_tex, gl_buf;
	string filename;

	void draw(vect2f &dst);
	void draw() {vect2f dst; dst = 0; draw(dst);}

	void load(string fn);
	void load(Array2D<vect4f> &img);
	void bind();
	void init();
	void release();
};

struct ImageRef
{
	ImageRef(){ptr = 0; refs = 0;}
	Image *ptr;
	int refs;

	void bind(){ptr->bind();}
};

struct ImageManager
{
	Image* alloc(string name);
	void free(Image* obj);

	map<string, ImageRef> images;
};
