#include "mip.h"
#include "global.h"
#include <GL/glew.h>

// This could be done more efficiently by using the tree structure rather than reading from the source image.

static void mip_img_box_dumb(Array2D<vect4f> &dst, Array2D<vect4f> &src, int size)
{
	dst.resize(src.s[0]/size, src.s[1]/size);
	double factor = 1.0 / (size*size);

	for (int y = 0; y < dst.s[1]; y++)
	{
		for (int x = 0; x < dst.s[0]; x++)
		{
			
			vect4f sum;
			sum = 0;
			for (int j = 0; j < size; j++)
			{
				for (int i = 0; i < size; i++)
				{
					sum += src(x*size + i, y*size + j);
				}
			}
			dst(x,y) = sum * factor;

		}
	}
}

void calc_mip_box_dumb(MipStack &mip, Array2D<vect4f> &src)
{
	mip.img.resize(g.num_mip_levels);
	mip.tex.resize(g.num_mip_levels);

	mip.img[0] = src;
	mip.tex[0].load(src);

	for (int i = 1; i < g.num_mip_levels; i++)
	{
		mip_img_box_dumb(mip.img[i], src, 1 << i);
	}

	// upload to opengl
	upload_texture(mip);
}