#include "mip.h"
#include "global.h"
#include <GL/glew.h>

void mip_img_box_rainbow(Array2D<vect4f> &dst, Array2D<vect4f> &src, int idx)
{
	vect4f color;
	color[3] = 1;

	float red[6] =   {1,1,1,0,0,0}; 
	float green[6] = {1,0,0,0,1,1}; 
	float blue[6] =  {0,0,1,1,1,0}; 

	color[0] = red[idx%6];
	color[1] = green[idx%6];
	color[2] = blue[idx%6];

	/*color[0] = .5 + .5*cos(idx * 2.0 * 3.14159 / 10.0);
	color[1] = .5 + .5*cos(idx * 2.0 * 3.14159 / 10.0 + 2.0 * 3.14159 / 3.0);
	color[2] = .5 + .5*cos(idx * 2.0 * 3.14159 / 10.0 + 4.0 * 3.14159 / 3.0);*/

	for (int i = 0; i < 3; i++)
		color[i] = color[i] * color[i];

	int size = 1 << idx;

	dst.resize(src.s[0]/size, src.s[1]/size);

	for (int y = 0; y < dst.s[1]; y++)
	{
		for (int x = 0; x < dst.s[0]; x++)
		{
			dst(x,y) = color;
		}
	}
}


void calc_mip_rainbow(MipStack &mip, Array2D<vect4f> &src)
{
	mip.img.resize(g.num_mip_levels);
	mip.tex.resize(g.num_mip_levels);

	// build mip images
	mip_img_box_rainbow(mip.img[0], src, 0);
	mip.tex[0].load(mip.img[0]);

	for (int i = 1; i < g.num_mip_levels; i++)
	{
		mip_img_box_rainbow(mip.img[i], src, i);
	}

	// upload to opengl
	upload_texture(mip);
}
